%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function [K_T_Data, K_R_Data] = Composite_Bearing_Stiffnesses(Fastener_Index, Layer, Oriented_Axis_vector, Ref_Dir_Vector)

global ErrCode;

global DB_ELEMENTS;
global DB_PSETS;
global DB_MATERIALS;

global AT_ELEMENTS;
global AT_PSETS;
global AT_MATERIALS;

global DB_FASTENERS;

K_T_Data = [];
K_R_Data = [];

% Формирование таблицы укладки

pset_type = DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(1))}.Prop_ID)}.type;

switch pset_type
        
    case {'PCOMP', 'PCOMPG'}
        
        N_Plies = DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(1))}.Prop_ID)}.N_plies;
        Stacking_Table = DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(1))}.Prop_ID)}.Laminate(:,1:3);

    case 'PSHELL'

        % Проверка типа материала
        mat_type = DB_MATERIALS{AT_MATERIALS(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(1))}.Prop_ID)}.Mat_ID_membrane)}.type;

        switch mat_type
            
            case {'2d_orthotropic', '2d_anisotropic'}
                
                N_Plies = 1;
                Stacking_Table = zeros(1,3);
                
                Stacking_Table(1,1) = DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(1))}.Prop_ID)}.Mat_ID_membrane;
                Stacking_Table(1,2) = DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Joint_mesh{Layer}.Element_list(1))}.Prop_ID)}.t;
                Stacking_Table(1,3) = 0;
                
            otherwise
                
                fprintf (1, '\nОшибка функции Composite_Bearing_Stiffnesses: недопустимый тип материала [%s] среди элементов присоединенной топологии [%s] болта %i !\n', mat_type, DB_FASTENERS{Fastener_Index}.Joint_topology{Layer}, Fastener_Index);
                ErrCode = -1;
                return;
                
        end

    otherwise

        fprintf (1, '\nОшибка функции Composite_Bearing_Stiffnesses: недопустимый тип property set [%s] среди элементов присоединенной топологии [%s] болта %i !\n', pset_type, DB_FASTENERS{Fastener_Index}.Joint_topology{Layer}, Fastener_Index);
        ErrCode = -1;
        return;

end

% Получение вектора нормали к пластине

Plate_Normal_Vector = Get_Plate_Normal(Fastener_Index, Layer);

if (ErrCode < 0)
    return;
end

% Получение вектора ориентации материала

Plate_Ori_Vector = Get_Plate_Orientation(Fastener_Index, Layer);

if (ErrCode < 0)
    return;
end

% Инвертирование укладки, если нормаль к пластине не сонаправлена с вектором оси болта

Dir_Sign = sign(dot(Plate_Normal_Vector, Oriented_Axis_vector));

if (Dir_Sign < 0)
    Stacking_Table = flip(Stacking_Table,1);
    Stacking_Table(:,3) = -Stacking_Table(:,3);
end

% Проецирование вектора ориентации материала на отсчетную плоскость

Projected_Plate_Ori_Vector = Plate_Ori_Vector - dot(Plate_Ori_Vector, Oriented_Axis_vector) * Oriented_Axis_vector;
Projected_Plate_Ori_Vector = Projected_Plate_Ori_Vector / norm(Projected_Plate_Ori_Vector);

% Вычисление угла смещения

Shift_Angle = acosd(dot(Ref_Dir_Vector, Projected_Plate_Ori_Vector)) * sign(dot(cross(Ref_Dir_Vector, Projected_Plate_Ori_Vector), Oriented_Axis_vector));

% % Поворот укладки (сохранено для возможного использования в будущем)
% Stacking_Table(:,3) = Stacking_Table(:,3) + ones(N_Plies,1)*Shift_Angle;

% Создание таблицы свойств материалов (plain stress reduced stiffness matrices)

Mat_Prop_Table = zeros(N_Plies, 6);

for i=1:N_Plies
    
    switch DB_MATERIALS{AT_MATERIALS(Stacking_Table(i,1))}.type
        
        case 'isotropic'
            
            E = DB_MATERIALS{AT_MATERIALS(Stacking_Table(i,1))}.E;
            nu = DB_MATERIALS{AT_MATERIALS(Stacking_Table(i,1))}.nu;
            G = E/2/(1+nu);
            
            Mat_Prop_Table(i,1) = E/(1 - nu*nu);
            Mat_Prop_Table(i,2) = nu*E/(1 - nu*nu);
            Mat_Prop_Table(i,3) = 0;
            Mat_Prop_Table(i,4) = E/(1 - nu*nu);
            Mat_Prop_Table(i,5) = 0;
            Mat_Prop_Table(i,6) = G;
            
        case '2d_orthotropic'
            
            E1 = DB_MATERIALS{AT_MATERIALS(Stacking_Table(i,1))}.E1;
            E2 = DB_MATERIALS{AT_MATERIALS(Stacking_Table(i,1))}.E2;
            G12 = DB_MATERIALS{AT_MATERIALS(Stacking_Table(i,1))}.G12;
            nu12 = DB_MATERIALS{AT_MATERIALS(Stacking_Table(i,1))}.nu12;
            nu21 = E2/E1 * nu12;
            
            Mat_Prop_Table(i,1) = E1/(1 - nu12*nu21);
            Mat_Prop_Table(i,2) = nu12*E2/(1 - nu12*nu21);
            Mat_Prop_Table(i,3) = 0;
            Mat_Prop_Table(i,4) = E2/(1 - nu12*nu21);
            Mat_Prop_Table(i,5) = 0;
            Mat_Prop_Table(i,6) = G12;
            
        case '2d_anisotropic'
            
            Mat_Prop_Table(i,1) = DB_MATERIALS{AT_MATERIALS(Stacking_Table(i,1))}.C(1,1);
            Mat_Prop_Table(i,2) = DB_MATERIALS{AT_MATERIALS(Stacking_Table(i,1))}.C(1,2);
            Mat_Prop_Table(i,3) = DB_MATERIALS{AT_MATERIALS(Stacking_Table(i,1))}.C(1,3);
            Mat_Prop_Table(i,4) = DB_MATERIALS{AT_MATERIALS(Stacking_Table(i,1))}.C(2,2);
            Mat_Prop_Table(i,5) = DB_MATERIALS{AT_MATERIALS(Stacking_Table(i,1))}.C(2,3);
            Mat_Prop_Table(i,6) = DB_MATERIALS{AT_MATERIALS(Stacking_Table(i,1))}.C(3,3);
            
        otherwise
            
            fprintf (1, '\nОшибка функции Composite_Bearing_Stiffnesses: обнаружен недопустимый тип материала [%s] при создании таблицы свойств материалов !\n', DB_MATERIALS{AT_MATERIALS(Stacking_Table(i,1))}.type);
            ErrCode = -1;
            return;
        
    end
    
end

% Матрицы жесткости ламината
[A1,B1,D1, A2,B2,D2] = Laminate_Stiffness_Matrices(N_Plies, Mat_Prop_Table, Stacking_Table(:,2), Stacking_Table(:,3)); %#ok<ASGLU>

% Жесткости пластины
K_T_plate_1 = A1(1,1); % смятие вдоль оси 1
K_R_plate_1 = D1(1,1); % смятие вдоль оси 1 за счет вращения вокруг оси 2
K_T_plate_2 = A2(2,2); % смятие вдоль оси 2
K_R_plate_2 = D2(2,2); % смятие вдоль оси 2 за счет вращения вокруг оси 1

% Параметры для расчета жесткостей болта
E_fastener = DB_MATERIALS{AT_MATERIALS(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Shank_elements(1))}.Prop_ID)}.Mat_ID)}.E;
t = sum(Stacking_Table(:,2));

% Жесткости болта
K_T_fast = E_fastener * t;
K_R_fast = 1/12 * t^3 * E_fastener;

% Объединенные жесткости
K_T_1 = 1 / (1/K_T_plate_1 + 1/K_T_fast);
K_T_2 = 1 / (1/K_T_plate_2 + 1/K_T_fast);
K_R_1 = 1 / (1/K_R_plate_1 + 1/K_R_fast);
K_R_2 = 1 / (1/K_R_plate_2 + 1/K_R_fast);

% Выделение памяти
K_T_Data = zeros(1,3);
K_R_Data = zeros(1,3);

% Заполнение жесткостей
K_T_Data(1,1) = K_T_1;
K_T_Data(1,2) = K_T_2;
K_R_Data(1,1) = K_R_1;
K_R_Data(1,2) = K_R_2;

% Заполнение угла смещения
K_T_Data(1,3) = Shift_Angle;
K_R_Data(1,3) = Shift_Angle;
